<html>
<head><title>NHPPS Changes and the Demonstration Pipeline</title></head>
<body>

<h1>NHPPS Changes and the Demonstration Pipeline</h1>

<h2>1. Introduction </h2>

<p> There have been a number of changes to the NHPPS code base for the
demonstration pipeline.  These occur in the NHPPS source, the nhppsapp
script, and the OGCE wrapper scripts.  The changes cover simplifying the
initial input, defining the output of the workflow as URI lists of files to
be persisted, and better structuring for the foreach-endfor version.

<h2>2. Input </h2>

<p> In the previous version the input was a file pointing to a file which
contains a list of OTA directories.  This double layer of indirection
has been removed so that the input need only be the file containing
the list of OTA directories.

<h2>3. Final Output </h2>

<p>The most important change is to clearly define the final output.
This is based on discussions held earlier.  In summary, it was decided
that the output consist of URI lists.  So the new version provides
three output parameter lists:

<ul>
<li>DataProducts
<li>DataLogs
<li>ProcessLogs
</ul>

<p>The data products are those files selected to be persisted and/or
passed on to the astronomers.  They are currently only FITS files and
in the final pipeline will mostly be FITS files.  However, there will
be the possiblity of other types of files such as graphics and text.
For the demonstration pipeline these may be used to develop the
interface between the output of AuCaP and the Data Engine.

<p>In order to be easily configurable and modular, the identification of
what is a data product is handled by a helper script (currently called
selectFiles.csh) which is input to the nhppsapp script rather than hardcode
it.  The selectFiles.csh script is given a list of all the files generated
by the pipeline up to that point and is then able to select those which are
data products.  This is, and will likely continue to be, a set of grep
commands based on the file name patterns.  For instance, the first simple
case is to pull out all the fits files.

<p>The other two lists are log information to be persisted for later
understanding the processing results or diagnosing problems with the
pipeline.  The data logs contain information organized by dataset and
pipeline.  These are primarily for collecting useful, data-oriented, output
from the stages and tasks in a pipeline.  This will primarily be for
scientific understanding.  No data logs are currently generated by the
demonstration pipeline.  The process logs contain information for each stage
and dataset; i.e. a process run on a particular dataset.  Process logs are
primarily for debugging and collecting error information.

<p>All files not listed in these output lists are to be considered as
transient working files that can be deleted after the pipeline has completed.

<p>In order to provide a single point of output, the workflow has been
redesigned to pass the output from earlier services on to later
ones so that the final service produces lists with all results from
the workflow.  The NHPPS pipeline applications do this automatically
but the restructuring in an OGCE workflow requires this be done
explicitly with input and output parameters.

<p> A simple change was required to the core NHPPS code to accomplish
this change.  The process logs written by NHPPS now use the extension
".plog" to allow discrimination with the dataset logs with use ".log".
The selection of output lists by the nhppsapp wrapper can then use
find and grep patterns.

<h2>4. Workflow Changes </h2>

<h3>4.1 Scripts </h3>

<p> The first, minor change is that all scripts are now csh and this is
made clear by using the .csh extension.  Previously there were .sh
files that were sometimes C-shell and sometimes Bourne-shell.

<h3>4.2 Foreach-Endfor </h3>

<p> The ODI workflow, as illustrated by the demonstration workflow, uses a
"map-reduce" logic appropriate for the highly data parallel nature of
ODI exposure processing.  A "map" step takes the output from a particular
OGCE service and break it into many parallel pieces which are input to
instances of the next service in the workflow.  This map function is also
known as "foreach" in the OGCE workflow context.  A "reduce" step takes the
output from many identical instances operating on pieces of the data and
merges them into a single input to the following service.  In the OGCE
context this is known as "endfor".

<p> The output of a service that is to be split into pieces by a foreach
operation is the parameter CallPipeList.  Each file in this output
list is used as the input list to an instance of the next service.
The design is such that the same list can be passed on to a single
instance of the service and the NHPPS pipeline will process all the
pieces in parallel but limited to the node on which it is executing.
This allows adjusting the amount of parallelization in the workflow
with no change other than removing the "foreach-endfor" elements.

<p> The output of a service has a parameter outList.  This is generally
passed on to the next service as the inList or inFiles parameter.  For an
end-for step the outLists are collected into a "list of lists" file.  This
is different that the earlier version where the endfor required the files
be concatenated.  The only requirement in creating the list of lists is that
the file name have the extension ".merge" to tell the next service that it
is the contents of all the files in the list that defines the input.

<p> For some services, and specifically the example case in the
demonstration pipeline, the input list is the output of the CallPipeList
from the preceding service.  When this occurs in an end-for step
the same thing is done as with the outList.  The lists are collected
in a list of lists with the ".merge" extension and used as the
inList for the next stage.

<p> As with the case of the foreach, this structure means that the
endfor can be dropped and the CallPipeList and outList can be
used directly as input to the next service without needing to change
the service.

<p> The two variants are illustrated by the following figures.  In
the first figure there is no foreach-endfor and the output and inputs
are directly connected.  In the second figure the arrow labeled with
"foreach" takes the output A:CallPipeList and feeds each file in that
output as the input to an instance of B.  The arrows labeled with
"endfor" take the outputs B:CallPipeList and B:outList and makes
lists of lists with the extension .merge.

<!--
<h4> Figure 1: (a) No foreach, (b) With foreach </h4>
<img src="fig1a.png"><img src="fig1b.png">
-->

<p>
<center><table width="600">
<tr>
<td valign="top">
<h4> Figure 1: No foreach </h4>
<div class=wsd wsd_style="qsd"><pre>
A->B: CallPipeList
B->C: CallPipeList
B->C: outList
</pre></div><script type="text/javascript"
src="http://www.websequencediagrams.com/service.js"></script>
<td valign="top">
<h4> Figure 2: With foreach </h4>
<div class=wsd wsd_style="qsd"><pre>
A-->B...: foreach:\nCallPipeList
B...-->C: endfor:\nCallPipeList
B...-->C: endfor:\noutList
</pre></div><script type="text/javascript"
src="http://www.websequencediagrams.com/service.js"></script>
</tr>
</table></center>

<p>The two versions are demonstrated at the Unix level by the odi_run
script shown below.

<blockquote>
<h4> Figure 3: odi_run script version </h4>
<pre>
#!/bin/csh -f

# This script can demonstrate with and without a parallel "foreach" loop.
# This is done with the argument "foreach".


# Define source path and working directory.
set src=/home/odipl/OGCEDemo/ogce_wrapper_scripts
set work=/pipefs/pipeline/odipl/OGCEData/ODI
#set src=/work/01437/ogce/odi/gateway_apps/odi_demo/ogce_wrapper_scripts
#set src=/work/01437/ogce/odi/Test

set path=($src $path)
cd $work

# Define input list and data product selection script.
# Change input list for a different size dataset.
set input = $src/test.list
set selectFiles = $src/selectFiles.csh

# This is to mimic OGCE capturing the standard output for extracting parameters.
set ogceout = $work/work_$$

# Service to convert the input list into input to the exp service.
#
# Input parameters:
#   URI input list
# Output parameters:
#   CallPipeList

setenv outputData `mktemp -d -p ${cwd} work_odi_to_expXXXXXX`
<b>odi_to_exp.csh</b> $input > ${ogceout}
set CallPipeList = `grep CallPipeList= ${ogceout} | sed -e 's/^.*=//'`
rm ${ogceout}*

# Flux calibrate the OTAs.
#
# Input parameters:
#   CallPipeList from odi_to_exp
#   Source file for selecting final data products
# Output parameters:
#   CallPipeList - URI file for triggering odi_stack
#   inFiles - URI file of final data products
#   parent - name of parent dataset

if ("$1" == "foreach") then

    foreach CallPipeList1 (`cat $CallPipeList`)
	setenv outputData `mktemp -d -p ${cwd} work_odi_expXXXXXX`
	<b>odi_exp.csh</b> $CallPipeList1 $selectFiles > $ogceout
	set CallPipeList = `grep CallPipeList= ${ogceout} | sed -e 's/^.*=//'`
	echo $CallPipeList >> ${ogceout}_CP.merge
	set inFiles = `grep outList= ${ogceout} | sed -e 's/^.*=//'`
	echo $inFiles >> ${ogceout}_inFiles.merge
	set parent = `grep parent= ${ogceout} | sed -e 's/^.*=//'`
	rm $ogceout
    end
    set CallPipeList = ${ogceout}_CP.merge
    set inFiles = ${ogceout}_inFiles.merge

else

    setenv outputData `mktemp -d -p ${cwd} work_odi_expXXXXXX`
    <b>odi_exp.csh</b> $CallPipeList $selectFiles > $ogceout
    set CallPipeList = `grep CallPipeList= ${ogceout} | sed -e 's/^.*=//'`
    set inFiles = `grep outList= ${ogceout} | sed -e 's/^.*=//'`
    set parent = `grep parent= ${ogceout} | sed -e 's/^.*=//'`
    rm $ogceout

endif

# Service to stack the exposures.
#
# Input parameters:
#   CallPipeList - from odi_exp
#   parent - from odi_exp
#   Source file - for selecting final data products
#   inFiles - outList from odi_exp
# Output parameters:
#   outFiles - URI of final data products

setenv outputData `mktemp -d -p ${cwd} work_odi_stackXXXXXX`
<b>odi_stack.csh</b> $CallPipeList $parent $selectFiles $inFiles > ${ogceout}
set dataProducts = `grep dataProducts= ${ogceout} | sed -e 's/^.*=//'`
set dataLogs = `grep dataLogs= ${ogceout} | sed -e 's/^.*=//'`
set processLogs = `grep processLogs= ${ogceout} | sed -e 's/^.*=//'`
rm ${ogceout}*

# Final data products.  These are the ones to save from demonstration.
echo Final Output:
if (-e $dataLogs) echo "  dataLogs=$dataLogs"
if (-e $processLogs) echo "  processLogs=$processLogs"
if (-e $dataProducts) then
echo "  dataProducts=$dataProducts"
cat $dataProducts
endif
</pre>
</blockquote>

<p><blockquote>
<h4> Figure 3a: Example run with short list "test.list" and without foreach </h4>
<pre>
pipefs$ <b>odi_run</b>
Final Output:
  dataLogs=/pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stacklZ7439/dataLogs.txt
  processLogs=/pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stacklZ7439/processLogs.txt
  dataProducts=/pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stacklZ7439/dataProducts.txt
+-->  /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test02-ota00/ota00.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test02-ota01/ota01.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test02-ota10/ota10.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test02-ota11/ota11.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test01-ota00/ota00.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test01-ota01/ota01.fits
+-->  /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test01-ota10/ota10.fits
      /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expOE4135/ODI/ODI_OTA/test-test01-ota11/ota11.fits
      /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stacklZ7439/ODI/ODI_ESK/test-stk-test01/test-test01.fits
      /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stacklZ7439/ODI/ODI_ESK/test-stk-test02/test-test02.fits
      /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stacklZ7439/ODI/ODI_STK/test-stk/test-stk.fits
</pre></blockquote>

<p><blockquote>
<h4> Figure 3b: Example run with short list "test.list" and with foreach </h4>
<pre>
pipefs$ <b>odi_run</b> <i>foreach</i>
Final Output:
  dataLogs=/pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stackR16840/dataLogs.txt
  processLogs=/pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stackR16840/processLogs.txt
  dataProducts=/pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stackR16840/dataProducts.txt
+-->  /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expM13369/ODI/ODI_OTA/test-test01-ota00/ota00.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expM13369/ODI/ODI_OTA/test-test01-ota01/ota01.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expM13369/ODI/ODI_OTA/test-test01-ota10/ota10.fits
+-->  /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expM13369/ODI/ODI_OTA/test-test01-ota11/ota11.fits
+-->  /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expZ15114/ODI/ODI_OTA/test-test02-ota00/ota00.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expZ15114/ODI/ODI_OTA/test-test02-ota01/ota01.fits
|     /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expZ15114/ODI/ODI_OTA/test-test02-ota10/ota10.fits
+-->  /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_expZ15114/ODI/ODI_OTA/test-test02-ota11/ota11.fits
      /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stackR16840/ODI/ODI_ESK/test-stk-test01/test-test01.fits
      /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stackR16840/ODI/ODI_ESK/test-stk-test02/test-test02.fits
      /pipefs/pipeline/odipl/OGCEData/ODI/work_odi_stackR16840/ODI/ODI_STK/test-stk/test-stk.fits
</pre></blockquote>

<p>The thing to note between the two runs is that in the foreach case the
working directories for odi_exp (work_odi_expXXXXXX) are different for the
test-test01 and test-test02 datasets.

</body></html>

